<?php
/*
Plugin Name: WP Content Filter
Plugin URI: http://gwycon.com/wp-content-filter-wordpress-plugin/
Description: Filters out profanity, and other words, specified in the Plugin options page.
Version: 1.0
Author: David Gwyer
Author URI: http://gwycon.com/
*/

/*  Copyright 2009 David Gwyer (email : d.v.gwyer(at)gwycon.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* --------------------------------- */
/* Admin Interface - START */ 
/* --------------------------------- */
function contfilt_admin() {
  include('contfilt_admin_form.php');
}

function gc_contfilt_admin_actions() { /* contfilt = content filter */ 
 add_options_page('WP Content Filter', 'WP Content Filter', 8, 'gc_contfilt_admin_actions_file_string', 'contfilt_admin');
}

function gc_contfilt_install(){
  if(!get_option('contfilt_keyword')){
    add_option('contfilt_keyword', 'saturn, pluto, jupiter');
  }

  if(get_option('contfilt_post' == '') || !get_option('contfilt_post')){
    add_option('contfilt_post', 'on');
  }

  if(get_option('contfilt_post_title' == '') || !get_option('contfilt_post_title')){
    add_option('contfilt_post_title', 'off');
  }

  if(get_option('contfilt_comment' == '') || !get_option('contfilt_comment')){
    add_option('contfilt_comment', 'on');
  }

  if(get_option('contfilt_tags' == '') || !get_option('contfilt_tags')){
    add_option('contfilt_tags', 'off');
  }

  if(get_option('contfilt_tag_cloud' == '') || !get_option('contfilt_tag_cloud')){
    add_option('contfilt_tag_cloud', 'off');
  }

  if(get_option('contfilt_case' == '') || !get_option('contfilt_case')){
    add_option('contfilt_case', 'insen');
  }

}

add_action('admin_menu', 'gc_contfilt_admin_actions');
add_action( 'plugins_loaded', 'gc_contfilt_install' );
  
/* --------------------------------- */
/* Admin Interface - END */ 
/* --------------------------------- */


/* --------------------------------- */
/* Plugin Code - START */
/* --------------------------------- */
function gc_filter($text) {
  $filter_type = get_option('contfilt_case');
  $db_search_string = get_option('contfilt_keyword');
  $search = explode(",", $db_search_string);
  $search = array_unique($search);

  foreach($search as $sub_search)
  {
   $sub_search = trim($sub_search);
   if(strlen($sub_search) > 2)
   {
	$tmp_search = substr($sub_search, 0, 1).str_repeat('*', strlen(substr($sub_search, 1)));
	// $sub_search = substr($sub_search, 0, 1).str_repeat('*', strlen(substr($sub_search, 1)));
    if($filter_type == "insen")
     { $text = str_ireplace($sub_search, $tmp_search, $text); }
    else
	 { $text = str_replace($sub_search, $tmp_search, $text); }
   }
  }

  return $text;
  /* return '$search = '.implode(",",$search).'<br />$replace = '.implode(",",$replace); */
}

if(get_option('contfilt_post') == 'on'){ add_filter('the_content', 'gc_filter'); }
if(get_option('contfilt_post_title') == 'on'){ add_filter('the_title', 'gc_filter'); }
if(get_option('contfilt_comment') == 'on'){ add_filter('comment_text','gc_filter'); }
if(get_option('contfilt_tags') == 'on'){ add_filter('term_links-post_tag', 'gc_filter' ); }
if(get_option('contfilt_tag_cloud') == 'on'){ add_filter('wp_tag_cloud', 'gc_filter'); }

/* --------------------------------- */
/* Plugin Code - END */
/* --------------------------------- */


/* --------------------------------- */
/* Internationalization Code - START */
/* --------------------------------- */
function contfilt_init() {
  load_plugin_textdomain('contfilt_domain', 'wp-content/plugins/wp-content-filter/i18n');
}

add_action('init', 'contfilt_init');
/* --------------------------------- */
/* Internationalization Code - END */
/* --------------------------------- */

?>